package com.sun.j3d.loaders.vrml97.impl;

/*
 *      @(#)Color.java 1.17 99/02/11 18:04:01
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

/*
 * @Author: Rick Goldberg
 * @Author: Doug Gehringer
 *
 */

import java.util.HashSet;
import java.util.Iterator;

public class Color extends Node  {
	// exposedField
	MFColor color;

	HashSet owners = new HashSet();

    public Color(Loader loader) {
	super(loader);
	color = new MFColor();
	initFields();	
    }
    public Color(Loader loader, MFColor color ) {
	super(loader);
	this.color = color;
	initFields();
    }
    public void addOwner(Node owner) {
	owners.add(owner);
    }
    public Object clone() {
	return new Color(loader, (MFColor)color.clone() );
    }
    public String getType() { return "Color"; }
    void initFields() {
	color.init(this, FieldSpec, Field.EXPOSED_FIELD, "color");
    }
    public void notifyMethod(String eventInName, double time) {
	if (eventInName.equals("color")) { 
	    for (Iterator oi = owners.iterator(); oi.hasNext() ; ) {
		Node owner = (Node) oi.next();
		owner.notifyMethod("color",time); 
	    }
	}

        if (eventInName.equals("route_color")) { 
	    for (Iterator oi = owners.iterator(); oi.hasNext() ; ) {
		Node owner = (Node) oi.next();
		owner.notifyMethod("route_color",time); 
	    }
	}
    }
}
