package com.sun.j3d.loaders.vrml97.impl;

/*
 *      @(#)CylinderSensor.java 1.17 98/11/05 20:34:23
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

/*
 * @Author: Rick Goldberg
 * @Author: Doug Gehringer
 *
 */

import javax.vecmath.Point3d;

public class CylinderSensor extends DragSensor {
	// exposedField
	SFFloat diskAngle;
	SFFloat maxAngle;
	SFFloat minAngle;
	SFFloat offset;
	// eventOut
	SFRotation rotation;

    public CylinderSensor(Loader loader) {
        super(loader);
        diskAngle = new SFFloat(0.0f);
        maxAngle = new SFFloat(0.0f);
        minAngle = new SFFloat(0.0f);
        offset = new SFFloat(0.0f);
        rotation = new SFRotation(0.0f,1.0f,0.0f,0.0f);
        initCylinderSensorFields();
    }
    public Object clone() {
        return new CylinderSensor(loader);
    }
    public String getType() { return "CylinderSensor"; }
	void initCylinderSensorFields() {
		diskAngle.init(this, FieldSpec, Field.EXPOSED_FIELD , "diskAngle");
		maxAngle.init(this, FieldSpec, Field.EXPOSED_FIELD, "maxAngle");
		minAngle.init(this, FieldSpec, Field.EXPOSED_FIELD, "minAngle");
		offset.init(this, FieldSpec, Field.EXPOSED_FIELD, "offset");
		rotation.init(this,FieldSpec,Field.EVENT_OUT,"rotation_changed");
	}
	void initFields() {
		super.initFields();
		initCylinderSensorFields();
	}
    public void notifyMethod(String eventInName, double time) {
    }
    void offset() {;}
    void simTick(double now) {;}
    void update(Point3d p1, Point3d p2, javax.media.j3d.Node node,
            javax.media.j3d.SceneGraphPath path) { System.out.println("CylinderSensor NYI");}
}
