package com.sun.j3d.loaders.vrml97.impl;

/*
 *      @(#)Group.java 1.31 98/11/05 20:34:30
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

/*
 * @Author: Rick Goldberg
 * @Author: Doug Gehringer
 *
 */

import java.util.Vector;
import javax.media.j3d.BoundingSphere;
import javax.vecmath.Point3d;

public class Group extends GroupBase {

	// all fields come from GroupBase

	javax.media.j3d.BranchGroup impl;

    public Group(Loader loader ) {
	super(loader);
    }
    Group(Loader loader, MFNode children, SFVec3f bboxCenter, 
		SFVec3f bboxSize ) {
	super(loader, children, bboxCenter, bboxSize);
    }
	public Object clone() {
	Object o = new Group( loader,
	    (MFNode)children.clone(), 
	    (SFVec3f)bboxCenter.clone(), 
	    (SFVec3f)bboxSize.clone() );
	return o;
	}
	public javax.media.j3d.Group getGroup() {
		return impl;
	}
    public String getType() { return "Group"; }
    void initFields() {
	initGroupBaseFields();
    }
	public void initImpl() {
		initImpl(new javax.media.j3d.BranchGroup());
	}
void initImpl(javax.media.j3d.BranchGroup g) {
	impl = g;
	implNode = impl;
	impl.setUserData(new Vector());
	super.replaceChildren(); // init the implGroup for clone()
	implReady = true;
	// Make sure that we can do reasonable things with the implimentation.
	impl.setCapability(javax.media.j3d.Group.ALLOW_CHILDREN_READ);
	impl.setCapability(javax.media.j3d.Group.ALLOW_CHILDREN_WRITE);
	impl.setCapability(javax.media.j3d.Group.ALLOW_CHILDREN_EXTEND);
	impl.setCapability(javax.media.j3d.BranchGroup.ALLOW_DETACH);

	//And the excessive features for touch sensors...
	impl.setCapability(javax.media.j3d.Group.ENABLE_PICK_REPORTING);
	impl.setCapability(javax.media.j3d.Group.ALLOW_BOUNDS_READ);
	impl.setCapability(javax.media.j3d.Group.ALLOW_LOCAL_TO_VWORLD_READ);
	impl.setCapability(javax.media.j3d.Group.ALLOW_PICKABLE_WRITE);
}
    public void notifyMethod(String eventInName, double time) {
	super.notifyMethod(eventInName, time);
    }
    public String toStringBody() {
	String retval = "Group # @" + Integer.toHexString(this.hashCode());
	retval += "\n{\n";
	retval += super.toStringBody();
	retval += "}";
	return retval;
    }
}
