package com.sun.j3d.loaders.vrml97.impl;

/*
 *      @(#)MFFloat.java 1.13 98/11/05 20:34:39
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

/*
 * @Author: Rick Goldberg
 * @Author: Doug Gehringer
 * @Author: Auvo Severinkangas
 *
 */

import java.util.Observer;
import java.util.Observable;

public class MFFloat extends MField implements MFNumeric {

	float[] mfloat;
    public MFFloat() {
	mfloat = new float[0];
    }
    public MFFloat(float values[]) {
	mfloat = new float[ values.length ];
	System.arraycopy(values,0,mfloat,0,values.length);

    }
    public void addValue(float f) {
	float[] temp = new float[mfloat.length + 1];
	System.arraycopy(mfloat,0,temp,0,mfloat.length);
	temp[mfloat.length] = f;
	mfloat = temp;

	route();
    }
    public void addValue(ConstSFFloat f) {
	addValue((SFFloat)f.ownerField);
    }
    public void addValue(SFFloat f) {
	addValue(f.value);
    }
    public void clear() { mfloat = new float[1]; }
    public synchronized Object clone() {
	return new MFFloat( mfloat );
    }
    public synchronized ConstField constify() {
	if (constField == null) {
	    constField = new ConstMFFloat(this);
	}
	return constField;
    }
    public void delete(int i) { ; } // TBD
    public float get1Value(int index) {
	float f=0.0f;
	f = mfloat[index];
	return f; 
    }
    public int getSize() { return mfloat.length; }
    public void getValue(float values[]) {
	System.arraycopy(mfloat,0,values,0,values.length);
    }
    public String getX3DValue()
    {
        StringBuffer sb = new StringBuffer(mfloat.length);
        for (int i = 0; i < getSize(); i++)
            sb.append(" "+ mfloat[i]);
        return sb.toString();
    }
    // the following needs double check
    public void insertValue( int index, float f ) {

	float[] temp = new float[mfloat.length + 1];
	System.arraycopy( mfloat,0,temp,0,index );
	temp[index] = f;
	System.arraycopy( mfloat,index,temp,index+1,mfloat.length - index );
	mfloat = temp;
	route();
    }
    public void insertValue( int index, ConstSFFloat f ) {
	insertValue( index, (SFFloat)f.ownerField );
    }
    public void insertValue( int index, SFFloat f ) {
	insertValue( index, f.value );
    }
    public void set1Value(int index, float f)
    {
	mfloat[index] = f;
	route();
    }
    public void set1Value(int index, ConstSFFloat f) {
	set1Value(index, (SFFloat)f.ownerField);
    }
    public void set1Value(int index, SFFloat f) {
	set1Value(index, f.value);
    }
    public void setValue(float[] values) {
	mfloat = new float[ values.length ];
	System.arraycopy( values,0,mfloat,0,values.length );
	route();
    }
    public void setValue(int size, float[] value) { 
	mfloat = new float[size];
	System.arraycopy( value,0,mfloat,0,size );
	route();
    }
    public void setValue(ConstMFFloat value) {
	setValue((MFFloat)value.ownerField);
    }
    public void setValue(MFFloat value) {
	setValue(value.mfloat);
    }
    public synchronized void update(Field field) {
	setValue((MFFloat)field );			
    }
    public vrml.Field wrap() {
        return new vrml.field.MFFloat(this);
    }
}
