package com.sun.j3d.loaders.vrml97.impl;

/*
 *      @(#)Normal.java 1.20 99/02/11 18:03:43
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

/*
 * @Author: Rick Goldberg
 * @Author: Doug Gehringer
 *
 */

import java.util.HashSet;
import java.util.Iterator;

public class Normal extends Node implements Reusable {

	// exposedField
	MFVec3f vector; 

	HashSet owners = new HashSet();;

    public Normal(Loader loader) {
	super(loader);
	vector = new MFVec3f( );
	initFields();
    }
    public Normal(Loader loader, float[] normals) {
	super(loader);
	this.vector = new MFVec3f(normals);
	initFields();
    }
    Normal(Loader loader, MFVec3f vectors ) {
	super(loader);
	this.vector = vectors;
	initFields();
    }
    public void addOwner(Node owner) {
	owners.add(owner);
    }
    public Object clone() {
	return new Normal(loader, (MFVec3f)vector.clone());
    }
    public String getType() { return "Normal"; }
    void initFields() {
	vector.init(this, FieldSpec, Field.EXPOSED_FIELD, "vector");
    }
    public void notifyMethod( String eventInName, double time ) {
	if (eventInName.equals("vector")) { 
	    for (Iterator oi = owners.iterator(); oi.hasNext() ; ) {
		Node owner = (Node) oi.next();
		owner.notifyMethod("normal",time); 
	    }
	}
	if (eventInName.equals("route_vector")) { 
	    for (Iterator oi = owners.iterator(); oi.hasNext() ; ) {
		Node owner = (Node) oi.next();
		owner.notifyMethod("route_normal",time); 
	    }
	}
    }
    public void reset() {
	vector.reset();
	owners.clear();
	implReady = false;
    }
    public String toStringBody() {
	return "Normal {\nvector " + vector + "}";
    }
}
