package com.sun.j3d.loaders.vrml97.impl;

/*
 *      @(#)SFBool.java 1.17 98/11/05 20:34:59
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

/*
 * @Author: Rick Goldberg
 * @Author: Doug Gehringer
 * @Author: Auvo Severinkangas
 *
 */

import java.util.Observer;
import java.util.Observable;

public class SFBool extends Field implements SFNumeric {

	boolean value;
	boolean initValue;

    public SFBool(boolean value) {
	this.value=value;
	initValue = value;
    }
    public synchronized Object clone() {
	return new SFBool( value );
    }
    public synchronized ConstField constify() {
	if (constField == null) {
	    constField = new ConstSFBool(this);
	}
	return constField;
    }
    public boolean getValue() {
	return value;
    }
    public String getX3DValue()
    {
        return (value ? "true" : "false");
    }
    void reset() {
	value = initValue;
    }
    public void setValue(ConstSFBool b) {
	setValue((SFBool)b.ownerField);
    }
    public void setValue(SFBool b) {
	setValue(b.value);
    }
    public void setValue(boolean b) {
	value=b;
	route();
    }
    public String toString() {
	return value + "\n";
    }
    public void update(Field field) {
	setValue( ((SFBool)field).getValue() );
    }
    public vrml.Field wrap() {
	return new vrml.field.SFBool(this);
    }
}
