package com.sun.j3d.loaders.vrml97.impl;

/*
 *      @(#)SFVec2f.java 1.11 98/11/05 20:35:44
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

/*
 * @Author: Rick Goldberg
 * @Author: Doug Gehringer
 * @Author: Auvo Severinkangas
 *
 */

import java.util.Observer;
import java.util.Observable;

public class SFVec2f extends Field implements SFNumeric {

	float[] vec2f = new float[2];

    public SFVec2f() {
    }
    public SFVec2f(float[] values) {
	setValue(values); 
    }
    public SFVec2f(float x, float y) {
	vec2f[0] = x; vec2f[1] = y;
    }
    public synchronized Object clone() {
        return new SFVec2f( vec2f );
    }
    public synchronized ConstField constify() {
	if (constField == null) {
	    constField = new ConstSFVec2f(this);
	}
	return constField;
    }
    public float[] getValue() {
	return vec2f;
    }
    public void getValue(float[] vec) {
	System.arraycopy(vec2f,0,vec,0,2);
    }
    public float getX() {
	return vec2f[0];
    }
    public String getX3DValue()
    {
        return vec2f[0] + " " + vec2f[1];
    }
    public float getY() {
	return vec2f[1];
    }
    public void setValue(float[] v) {
	try {
           System.arraycopy(v,0,vec2f,0,2);
    	   route();
        }
        catch  ( Exception e ) {
           System.err.println( "You need to instance enough float to get by ");
        }

    }
    public void setValue(float x, float y) {
	vec2f[0] = x;
	vec2f[1] = y;
	route();
    }
    public void setValue(ConstSFVec2f v) {
	setValue((SFVec2f)v.ownerField);
    }
    public void setValue(SFVec2f v) {
	setValue(v.getValue());
    }
    public void update(Field field) {
	setValue((SFVec2f)field );
    }
    public vrml.Field wrap() {
        return new vrml.field.SFVec2f(this);
    }
}
