package com.sun.j3d.loaders.vrml97.impl;

import javax.vecmath.*;
import javax.media.j3d.ViewPlatform;

/**
 * The idea behind SimpleViewpoint is to construct a VRML node which
 * performs the viewpoint and navigation functionality in as simple a
 * manner as possible while making the fewest changes to the VRML
 * system.
 */
public class SimpleViewpoint extends com.sun.j3d.loaders.vrml97.impl.Transform implements edu.nodak.ndsu.VRML.KeyboardNavigatorParent {
    edu.nodak.ndsu.VRML.MyKeyNavigatorBehavior knb;
 edu.nodak.ndsu.VRML.MyMouseRotate mrb;
    SFBool set_bind;
    MFNode geometry;
	ViewPlatform viewplatform;	
/**
 * SimpleViewpoint constructor comment.
 * @param loader com.sun.j3d.loaders.vrml97.impl.Loader
 */
public SimpleViewpoint(com.sun.j3d.loaders.vrml97.impl.Loader loader) {
	super(loader);
	set_bind=new SFBool(false);
	set_bind.init(this, FieldSpec, Field.EVENT_IN, "set_bind");
	//geometry=new MFNode();
	//geometry.init(this, FieldSpec, Field.EXPOSED_FIELD, "geometry");
	// removeChildren and addChildren are from Group
}
/**
 * SimpleViewpoint constructor comment.
 * @param loader com.sun.j3d.loaders.vrml97.impl.Loader
 */
public SimpleViewpoint(com.sun.j3d.loaders.vrml97.impl.Loader loader, MFNode children,
	SFVec3f bboxCenter, SFVec3f bboxSize, SFVec3f center, SFRotation rotation,
	SFVec3f scale, SFRotation scaleOrientation, SFVec3f translation) {
	super(loader, children, bboxCenter, bboxSize, center, rotation, scale, scaleOrientation,
		translation);
	set_bind=new SFBool(false);
	set_bind.init(this, FieldSpec, Field.EVENT_IN, "set_bind");
	//geometry=new MFNode();
	//geometry.init(this, FieldSpec, Field.EXPOSED_FIELD, "geometry");
	// removeChildren and addChildren are from Group
}
/**
 * Cause the Browser's View to bind with this ViewPlatform.
 */
public void acquireView() {
	/* There doesn't seem to be a way of detatching the old ViewPlatform */
	browser.getView().attachViewPlatform(viewplatform);
}
    public Object clone() {
        if (loader.debug) {
            System.out.println("Transform.clone() called");
        }
        return new SimpleViewpoint(
            loader, 
            (MFNode) children.clone(), 
            (SFVec3f) bboxCenter.clone(), 
            (SFVec3f) bboxSize.clone(), 
            (SFVec3f) center.clone(), 
            (SFRotation) rotation.clone(), 
            (SFVec3f) scale.clone(), 
            (SFRotation) scaleOrientation.clone(), 
            (SFVec3f) translation.clone()); 
    }
/**
 * Insert the method's description here.
 * Creation date: (5/4/01 12:44:31 PM)
 */
public void initImpl() {
	super.initImpl();
	viewplatform = new ViewPlatform();
	edu.nodak.ndsu.VRML.TactileSensorBehavior tsb=new edu.nodak.ndsu.VRML.TactileSensorBehavior(this);
	tsb.setSchedulingBounds(new javax.media.j3d.BoundingSphere());
	knb=new edu.nodak.ndsu.VRML.MyKeyNavigatorBehavior(transform, this);
	knb.setSchedulingBounds(new javax.media.j3d.BoundingSphere());
	mrb=new edu.nodak.ndsu.VRML.MyMouseRotate(transform);
	mrb.setSchedulingBounds(new javax.media.j3d.BoundingSphere());
	edu.nodak.ndsu.VRML.MyMouseBehaviorCallback callback=new edu.nodak.ndsu.VRML.MyMouseBehaviorCallback() {
		public void transformChanged( int type, javax.media.j3d.Transform3D transform ) {
			//double vpScale;
			Quat4f vpQuat=new Quat4f();
			//Vector3f vpPos=new Vector3f();
			//vpScale = transform.get(vpQuat, vpPos);
			transform.get(vpQuat);
			AxisAngle4f vpRotation=new AxisAngle4f();
			vpRotation.set(vpQuat);
//			System.out.println("Position: "+vpPos.x+","+vpPos.y+","+vpPos.z);
//			System.out.println("Rotation: "+vpRotation.x+","+vpRotation.y+","+vpRotation.z+" at "+vpRotation.angle);
			notifyUserOrientationChanged(vpRotation.x, vpRotation.y, vpRotation.z, vpRotation.angle);
		}
	};
	transform.setCapability(javax.media.j3d.TransformGroup.ALLOW_TRANSFORM_READ);
	transform.setCapability(javax.media.j3d.TransformGroup.ALLOW_TRANSFORM_WRITE);
	transform.addChild(viewplatform);
	transform.addChild(knb);
	transform.addChild(mrb);
	transform.addChild(tsb);
}
public void notifyMethod(String eventName, double time) {
	if (eventName.equals("set_bind")) {
		if (set_bind.getValue()) {
			System.out.println("Acquiring view.");
			acquireView();
		}
	} else if (eventName.equals("translation")) {
		/* Reset user position */
		super.notifyMethod(eventName, time);
		knb.resetUserPosition(translation.getX(), translation.getY(), translation.getZ());
	} else if (eventName.equals("rotation")) {
		/* Reset user position */
		super.notifyMethod(eventName, time);
		knb.resetUserOrientation(rotation.getX(), rotation.getY(), rotation.getZ(), rotation.getAngle());
	} else {
		super.notifyMethod(eventName, time);
	}
}
/**
 * notifyUserOrientationChanged method comment.
 */
public void notifyUserOrientationChanged(float x, float y, float z, float angle) {
	rotation.rot[0]=x;
	rotation.rot[1]=y;
	rotation.rot[2]=z;
	rotation.rot[3]=angle;
	rotation.routeUpdate(false);
}
/**
 * notifyUserTranslationChanged method comment.
 */
public void notifyUserTranslationChanged(float x, float y, float z) {
	translation.value[0]=x;
	translation.value[1]=y;
	translation.value[2]=z;
	translation.routeUpdate(false);
}
}
